Subject: Re: [bitcoin-dev] BIP Process and Votes

From: Jorge Timón <[email-masked]>
Date: Sun, 28 Jun 2015 17:35:17 +0200

On Sun, Jun 28, 2015 at 3:13 PM, Milly Bitcoin <[email-masked]> wrote:
> I never said something was approved by garzik added something after it was
> opposed.  What I said was a proposal was made and 4 people commented on the
> Github.  He then tweeted there was near universal approval before most
> people even heard about the subject.  It was not controversial but i was
> pointing out the arrogance of some of the developers.  He considers the
> entire universe of Bitcoin stakeholders to be a very small group of
> insiders, not the entire universe of Bitcoin users.  Another thing I have
> seen on Github for bitcoin.org is how some the maintainers change the rules
> on the fly.  Sometimes they say a proposal had no objections so it is
> approved.  Other times they say a proposal has no support so it is rejected.

Ok, I misunderstood.
Well, the fact is that the number of capable reviewers is quite small.
If more companies hired and trained more developers to become bitcoin
core developers that situation could change, but that's where we are
now.

> You are also trying to say that the core developers actually have little
> influence and are not "deciders" because anyone can fork the code.  That has
> already been discussed at length and such an argument is faulty because
> there is a constraint that your software is incompatible with everyone else.

Only if you change the consensus rules (which are, in fact, a
relatively small part of the code).
Mike mantains Bitcoin XT and that's fine, Peter Todd maintains patches
with the replace by fee policy, libbitcoin also changes many
non-consensus things, there's code written in other languages...
There's multiple counter-examples to your claim of that argument being faulty.
Seriously, forking the project is just one click. You should try it
out like at least 9627 other people have done.
>From there, you can pay your own developers (if you don't know how to
code yourself) and maybe they're also fine being insulted by you as
part of the job.
What you still can't do is unilaterally change the consensus rules of
a running p2p consensus system, because you cannot force the current
users to run any software they don't want to run.

> The issue is that there is no way right now to change the consensus rules
> except to go through the core maintainer unless you get everybody on the
> network to switch to your fork.  People who keep repeating that the software
> development is "decentralized because you fork the code" without explaining
> the constraints are just cultists.

Please, stop the cultist crap. Maybe insulting people like that is how
you got people to call you a troll.
But, yes, you are right: there's no known mechanism for safely
deploying controversial changes to the consensus rules

> The discussion has nothing to do with who has the position now and I never
> said he has "control over the consensus rules."  The maintainer has a very
> large influence way beyond anyone else.  As for your claim that I want
> someone hurt because I am explaining the process, that is ridiculous.  If
> the Core maintainers did not have significant influence to change the
> consensus rules then everybody would not be spending all this time lobbying
> them to have them changed.

Well, if you don't think he has control over the consensus rules we're
advancing.
I think that was implied from some of your previous claims. He is no
"decider" on consensus changes.
Insisting on it can indeed get him hurt, so I'm happy that you're
taking that back (or clarifying that really wasn't your position).
Influence is very relative and not only core devs have "influence".
Maybe Andreas Antonopolous has more "influence" than I have because he
is a more public figure?
Well, that's fine I think. I don't see the point in discussing who has
how much influence.

> The outside influences and stake of the developer is a relevant topic.  The
> same types of things are discussed on this list all the time in the context
> of miners, users, merchants, and exchanges.  Again, the developers try to
> place themselves on some kind of pedestal where they are the protectors and
> pure and everyone else (miners, users, merchants) are abusers, spammers,
> attackers, scammers, cheaters, etc.  It is Garzik who voluntarily made an
> issue of how many bitcoins he holds and he made that issue in the same place
> where he announces many of the technical issues.  It is very relevant that
> he has a minimal stake in Bitcoin holdings yet he goes around making major
> decisions about Bitcoin and trying to dictate who is allowed to participate
> in discussions.  If a core developer has minimal stake in Bitcoin yet has
> major veto power over code change that is a problem.

Please, don't generalize. I don't think I put myself in any kind of pedestal.
That is insulting to me and many others (you may not even know and
you're insulting them).
And I think my Bitcoin holdings are completely irrelevant when judging
my contributions to the software: either they're good or not, and who
I am or how many Bitcoins I have at any given time shouldn't matter.
Again, nobody forces you to use our software, as said there's
alternatives (including forking the project right now).

> You are correct that you cannot give power to any person over the Internet
> which is why some kind of process needs to be developed that does not
> involve trying to convince one person to make the changes or a system that
> depends on unwritten, ever-changing rules maintained by a handful of people.

Well, for now the process we have is seeking consensus, and although
our definition of "uncontroversial" is very vague, I think it is quite
obvious when a proposed change is not "uncontroversial" (like in the
block size debate).
It seems to me that any other "formal process" would imply
centralization in the decision making of the consensus rules (and from
there you only have to corrupt that centralized organization to
destroy Bitcoin).